----------- inverter.vhd -----------------------------------------------------------
--
--  Description
--      Inverseur
--
--  Ports
--		x	:	input
--		xn	:	output, inverse of x
--
------------------------------------------------------------------------------------------
--  Author
--      Mostafa Darvishi
--
--  Date Creation
--      2017-05-30
--
--  Date Modification
--      2017-05-30
--
--  Sources
--        MQP Pierre-Louis et Wells p.38
------------------------------------------------------------------------------------------
--  Notes
------------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;
------------------------------------------------------------------------------------------
entity inverter is
  port (	x	: in  std_logic ;
			xn	: out std_logic);
end entity ; -- inverter
------------------------------------------------------------------------------------------
architecture behavior of inverter is 

attribute KEEP : string;
attribute S    : string;


signal xs : std_logic;

attribute KEEP of xs : signal is "TRUE";
attribute S    of xs : signal is "TRUE";


begin
	xn	<= not xs;   -- it was xn	<= not x;

xs <= x;
end architecture ; -- behavior
------------------------------------------------------------------------------------------
