----------------------------------------------------------------------------------
-- Company: 
-- Engineer: Mostafa Darvishi
-- 
-- Create Date:    13:42:18 06/08/2017 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;
library UNISIM;
use UNISIM.VComponents.all;

entity top is
    Port ( sys_clk 	    : in  STD_LOGIC;
           reset 		: in  STD_LOGIC;
           --osc_clk 	: in  STD_LOGIC;
           cut          :  in STD_LOGIC;
           start 		: in  STD_LOGIC;
		   enable		: in  STD_LOGIC;
           prd 		    : out  STD_LOGIC_VECTOR (31 downto 0);  --was  (9 downto 0)
           done_tick    : out  STD_LOGIC;
           ready 		: out  STD_LOGIC);
end top;

architecture Behavioral of top is

attribute keep              :  string;
attribute S                 :  string;
attribute keep_hierarchy    :  string;


	signal countx 	   : std_logic_vector (31 downto 0) := (others => '0');
	--signal county 	   : std_logic_vector (3 downto 0) := (others => '0');
	signal six         : std_logic;
	signal osc_clk     : std_logic;
    signal osc_clkg    : std_logic;

	 



	attribute keep of countx     : signal is "TRUE";
	--attribute keep of county     : signal is "TRUE";
	attribute keep of six        : signal is "TRUE";
    attribute keep of osc_clk    : signal is "TRUE";
    attribute keep of osc_clkg   : signal is "TRUE";
	attribute S    of countx     : signal is "TRUE";
	--attribute S    of county     : signal is "TRUE";
	attribute S    of six        : signal is "TRUE";
	attribute S    of osc_clk    : signal is "TRUE";
	attribute S    of osc_clkg    : signal is "TRUE";
	
	attribute keep_hierarchy of cntr_1    : label is "yes";
--	attribute keep_hierarchy of prd_contr : label is "yes";
    attribute keep_hierarchy of ringosc   : label is "yes";








------------------ BUFG DECLARATION -------------------

        component BUFG
                    port( I     :   in      STD_LOGIC; 
                          O     :   out     STD_LOGIC);
        end component;
----------------------------------------------------------



------------------ PRE-COUNTER CIRCUIT -------------------
		component counter1 is
					port ( clk 	    	: in  	STD_LOGIC;
							 rst 	    : in  	STD_LOGIC;
							 en  	    : in  	STD_LOGIC;
							 count 	    : out  	STD_LOGIC_VECTOR (31 downto 0);
							 ref_pulse  : out  	STD_LOGIC);
		end component;
----------------------------------------------------------


------------------- PERIOD COUNTER CIRCUIT ----------------
        component period_counter IS
					port (	clk, reset                  : IN  std_logic;
								start, si        		: IN  std_logic;
								ready, done_tick 		: OUT std_logic;
								prd              		: OUT std_logic_vector(31 DOWNTO 0));  -- was  (9 DOWNTO 0)
        end component;
----------------------------------------------------------


------------------- RING OSCILLATOR CIRCUIT ----------------

        component ringOscillator is
                    port (  en	: in  std_logic ;
                            cut : in  std_logic ;
			                y	: out std_logic);
			           
        end component;
----------------------------------------------------------



begin


-------------- components instantiation --------------------

cntr_1  :  counter1 port map(
									clk  		=> 	        sys_clk,
									rst			=>		    reset,
									en          =>          enable,
									count		=>		    countx,
									ref_pulse	=> 	        six);



ringosc : ringOscillator  port map(
                                    en   =>   enable,
                                    cut  =>   cut,
                                    y    =>   osc_clk);
                                    
                                    


prd_contr : period_counter port map(
											clk			=> 	  osc_clkg,
											reset		=>    reset,
											start		=>    start,
											si        	=>    six,
											ready		=>    ready,
											done_tick 	=>    done_tick,
											prd         =>    prd);


global_buffer  :  BUFG  port map (
                                            I           =>    osc_clk,
                                            O           =>    osc_clkg);





--process (reset, osc_clkg,six)
--begin
--    if (reset = '1')  then
--        county <= (others => '0');
--    elsif (six = '1') then 
--        if (osc_clk'event and osc_clk='1') then
--            county <= county + 1;
--        end if;
--    end if;
--end process;


--prd  <=  county;





end Behavioral;

